import {
  RECEIVE_ORDER,
  RECEIVE_ORDERS,
  UPDATE_ORDER,
} from "../../actions/order_actions";

const initialState = {
  byId: {},
  allIds: [],
};

const OrdersReducer = (oldState = initialState, action) => {
  Object.freeze(oldState);
  const newState = { ...oldState };
  const order = action.order || null;

  switch (action.type) {
    case RECEIVE_ORDERS:
      return action.payload;
    case RECEIVE_ORDER:
      newState.byId[order.id] = order;
      newState.allIds.unshift(order.id);
      return newState;
    case UPDATE_ORDER:
      newState.byId[order.id] = order;
      return newState;
    default:
      return oldState;
  }
};

export default OrdersReducer;
